//+------------------------------------------------------------------+
//|                                                    Color rsx.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DimGray
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DeepSkyBlue
#property indicator_color4  Red
#property indicator_color5  Red
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_minimum 0
#property indicator_maximum 100
 
//
//
//
//
//

extern string TimeFrame   = "current time frame";
extern int    RsxPeriod   = 14;
extern int    RsxPrice    =  0;
extern double OverBought  = 70;
extern double OverSold    = 30;
extern bool   Interpolate = true;

extern bool   showArrows       = false;
extern string arrowsIdentifier = "ColorRsxArrows";
extern color  arrowsUpColor    = DeepSkyBlue;
extern color  arrowsDnColor    = Red;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//
//

double rsx[];
double Lowera[];
double Lowerb[];
double Uppera[];
double Upperb[];
double trend[];

//
//
//
//
//

int    timeFrame;
string IndicatorFileName;
bool   CalculateValue;
bool   ReturningBars;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,rsx);    SetIndexLabel(0,"Deviations");
      SetIndexBuffer(1,Uppera); SetIndexLabel(1,NULL);
      SetIndexBuffer(2,Upperb); SetIndexLabel(2,NULL);
      SetIndexBuffer(3,Lowera); SetIndexLabel(3,NULL);
      SetIndexBuffer(4,Lowerb); SetIndexLabel(4,NULL);
      SetIndexBuffer(5,trend);
      
      //
      //
      //
      //
      //
         
         IndicatorFileName = WindowExpertName();
         CalculateValue    = (TimeFrame=="calculateValue"); if (CalculateValue) { showArrows=False; return(0); }
         ReturningBars     = (TimeFrame=="returnBars");     if (ReturningBars)  { showArrows=False; return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
            SetLevelValue(0,OverBought);
            SetLevelValue(1,OverSold);
      
   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" color rsx ("+RsxPeriod+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   if (showArrows) deleteArrows(); return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][13];

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ReturningBars)  { rsx[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (CalculateValue || timeFrame==Period())
   {
      double Kg = (3.0)/(2.0+RsxPeriod);
      double Hg = 1.0-Kg;

      //
      //
      //
      //
      //
            
      if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
      if (trend[limit]== 1) CleanPoint(limit,Uppera,Upperb);
      if (trend[limit]==-1) CleanPoint(limit,Lowera,Lowerb);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,RsxPrice,i);

         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

         //
         //
         //
         //
         //
      
         double roc = wrkBuffer[r][12]-wrkBuffer[r-1][12];
         double roa = MathAbs(roc);
         for (int k=0; k<3; k++)
         {
            int kk = k*2;
               wrkBuffer[r][kk+0] = Kg*roc                + Hg*wrkBuffer[r-1][kk+0];
               wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; roc = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
               wrkBuffer[r][kk+6] = Kg*roa                + Hg*wrkBuffer[r-1][kk+6];
               wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; roa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
         }
         if (roa != 0)
              rsx[i] = MathMax(MathMin((roc/roa+1.0)*50.0,100.00),0.00); 
         else rsx[i] = 50.0;

         //
         //
         //
         //
         //
         
         Uppera[i] = EMPTY_VALUE;
         Upperb[i] = EMPTY_VALUE;
         Lowera[i] = EMPTY_VALUE;
         Lowerb[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (rsx[i] > OverBought)                    trend[i] =  1;
            if (rsx[i] < OverSold)                      trend[i] = -1;
            if (rsx[i] < OverBought && rsx[i]>OverSold) trend[i] =  0;
            if (trend[i]== 1) PlotPoint(i,Uppera,Upperb,rsx);
            if (trend[i]==-1) PlotPoint(i,Lowera,Lowerb,rsx);

         manageArrow(i);
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
            
   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend[limit]==-1) CleanPoint(limit,Lowera,Lowerb);
   if (trend[limit]== 1) CleanPoint(limit,Uppera,Upperb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         rsx[i]    = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxPeriod,RsxPrice,OverBought,OverSold,0,y);
         trend[i]  = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxPeriod,RsxPrice,OverBought,OverSold,5,y);

            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               double factor = 1.0 / n;
               for(k = 1; k < n; k++)
                  rsx[i+k] = k*factor*rsx[i+n] + (1.0-k*factor)*rsx[i];
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
         Uppera[i] = EMPTY_VALUE;
         Upperb[i] = EMPTY_VALUE;
         Lowera[i] = EMPTY_VALUE;
         Lowerb[i] = EMPTY_VALUE;
         if (trend[i]==-1) PlotPoint(i,Lowera,Lowerb,rsx);
         if (trend[i]== 1) PlotPoint(i,Uppera,Upperb,rsx);
               manageArrow(i);
   }      
   manageAlerts();
      
   //
   //
   //
   //
   //
   
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (!CalculateValue && showArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1)                     drawArrow(i,arrowsUpColor,241,false);
         if (trend[i] ==-1)                     drawArrow(i,arrowsDnColor,242,true);
         if (trend[i+1] == 1 && trend[i] !=  1) drawArrow(i,arrowsDnColor,242,true);
         if (trend[i+1] ==-1 && trend[i] != -1) drawArrow(i,arrowsUpColor,241,False);
      }
   }               
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!CalculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));

      //
      //
      //
      //
      //
         
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]   ==  1)                        doAlert(whichBar,DoubleToStr(OverBought,2)+" croosed up");
         if (trend[whichBar]   == -1)                        doAlert(whichBar,DoubleToStr(OverSold,2)  +" croosed down");
         if (trend[whichBar+1] ==  1 && trend[whichBar]!= 1) doAlert(whichBar,DoubleToStr(OverBought,2)+" croosed down");
         if (trend[whichBar+1] == -1 && trend[whichBar]!=-1) doAlert(whichBar,DoubleToStr(OverSold,2)  +" croosed up");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," color rsx level ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"color rsx"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}